const _un           = undefined;
const _nu           = null;
const _t            = true;
const _f            = false;


const {
  _J,_JSN_ENCD,_V8SER_ENCD,_BUF_ENCD$S,
  _s2j,_j2s,_v8ser,_v8dsr,_b2s,_s2b,_o2s,_s2o,
  _encd8ser,_encdjsn,
  _decd
}                   = require("nv-facutil-simple-serde");

const creat_id_pool = require("nv-facutil-simple-pairid").creat;

const {RD}          = require("nv-redis-fetch");


class RedisCfg {
     password='redis';
     db =15;
     port=6379;
     host='127.0.0.1';
     family=4
}

//


////------------

const _decd_rv      = (rv_str)=> {
     let  rv       = _s2j(rv_str);
     //
     let  [vtype,arg_ary,max_retry_times,intv] = rv;
     if(vtype === _JSN_ENCD) {
         return([vtype,arg_ary,max_retry_times,intv,_un])      
     } else {
         let arg_ary_buf_str = arg_ary;
         arg_ary  = _s2o(arg_ary);
         return([vtype,arg_ary,max_retry_times,intv,arg_ary_buf_str])
     }
}
const _updt_rv    = (vtype,arg_ary,max_retry_times,intv,arg_ary_buf_str)=> {
      let nrv;
      if(vtype === _JSN_ENCD) {
           nrv = [vtype,arg_ary,max_retry_times,intv]
      } else {
           nrv = [vtype,arg_ary_buf_str,max_retry_times,intv]
      }
      let nrv_str = _j2s(nrv);
      return(nrv_str) 
}
const _encd_rv  =   (vtype,arg_ary,max_retry_times,intv) => {
     let nrv = [_JSN_ENCD,arg_ary,max_retry_times,intv];
     let nrv_str = '';
     if(vtype === _JSN_ENCD) {    
     } else {
         let arg_ary_buf_str = _o2s(arg_ary);
         nrv[0] = _V8SER_ENCD;
         nrv[1] = arg_ary_buf_str;
     }
     nrv_str = _j2s(nrv);
     return(nrv_str)
}

const _add_retry_task = async (
    that,
    id,rid,
    vtype,
    handle,
    arg_ary,
    max_retry_times=1,
    init_intv=60000,
    next_intv_func
) => {
     /*
      *  handle(lefted_retry_times,...arg_ary)
      *  如果 next_intv 是 undefined max_intv 无用
      */
     let pool      = that.handle_pool;
     pool[id]      = [handle,rid,next_intv_func]
     let rv_str    = _encd_rv(vtype,arg_ary,max_retry_times,init_intv);
     await that.rd_.set(rid,rv_str);
     await that.rd_.set(id,_nu);
     await that.rd_.pexpire(id,init_intv);            //启动
     return([id,rid])
}


const MAX_20MIN_NEXT_INTV   = (intv) => {
    if(intv < 20*60*1000) {
         intv = intv*2
    } else {}
    return(intv)
}

class RRetry extends RD {
    handle_pool      = {};        // id : [handle,rid]   id:expire rid real
    handle_wrap      = _nu;
    #get_nid         = creat_id_pool(2**48-1);
    constructor(rdcfg=new RedisCfg()) {
        super(rdcfg.password,rdcfg.db,rdcfg.port,rdcfg.host,rdcfg.family);
        ////----注册expire noti
        let self = this;
        this.handle_wrap = async function(id) {
             let  pool                           = self.handle_pool;
             if(pool[id]) {
                 let  [handle,rid,next_intv_func]                 = pool[id];
                 let  rv_str                                      = await self.rd_.get(rid);
                 let [vtype,arg_ary,max_retry_times,intv,arg_ary_buf_str] = _decd_rv(rv_str);   
                 // arg_ary_buf_str is V8SER of arg_ary , USED WHEN VTYPE IS v8ser
                 //------------
                 let lefted_retry_times = max_retry_times;
                 let [succ,R] = await handle(lefted_retry_times,...arg_ary);
                 //------------
                 max_retry_times = max_retry_times -1;
                 if((max_retry_times ===0) || (succ===_t)) {
                      delete pool[id];              //删除handle 
                      await self.rd_.del(rid);      //删除rv
                 } else {
                      // next_intv_func下一轮延迟的计算规则
                      if(next_intv_func) { intv = next_intv_func(intv);} else {}
                      let nrv_str = _updt_rv(vtype,arg_ary,max_retry_times,intv,arg_ary_buf_str);
                      // 如果编码是 V8SER, 则直接使用原来的 arg_ary_buf_str 避免再次 serde
                      await self.rd_.set(rid,nrv_str);  //更新 max_retry_times
                      await self.rd_.set(id,_nu);       //键值永远为null
                      await self.rd_.pexpire(id,intv);
                 }
                 return([succ,R])
             } else {
                 //任务已经被cancel
                 return(_nu)
             }
        };
    }
    async init() {
        await this.conn();
        await this.regis_expired_noti(this.handle_wrap);
    }
    async add_retry_task(handle,arg_ary,max_retry_times=1,init_intv=60000,next_intv_func) {
        let [id,rid]  = this.#get_nid();
        _add_retry_task(this,id,rid,_V8SER_ENCD,handle,arg_ary,max_retry_times,init_intv,next_intv_func);
        return([id,rid])
    }
    async add_json_only_retry_task(handle,arg_ary,max_retry_times=1,init_intv=60000,next_intv_func) {
         /*
          *  handle(lefted_retry_times,...arg_ary)
          *  如果 next_intv 是 undefined max_intv 无用
          */
         let [id,rid]  = this.#get_nid();
         _add_retry_task(this,id,rid,_JSN_ENCD,handle,arg_ary,max_retry_times,init_intv,next_intv_func);
         return([id,rid])    
    }
    async update_retry_task(
         id,
         {     
            new_vtype,
            new_handle,
            new_arg_ary,
            new_max_retry_times,
            new_init_intv,
            new_next_intv_func
         }
    ) {
         let pool         = this.handle_pool;
         if(pool[id]) {
              //必须存在
              let [handle,rid,next_intv_func] = pool[id];
              new_handle                      = new_handle??handle;
              new_next_intv_func              = new_next_intv_func??next_intv_func;
              ////
              let  rv_str                                      = await self.rd_.get(rid);
              if(rv_str !== _nu) {
                  let [vtype,arg_ary,max_retry_times,intv,arg_ary_buf_str] = _decd_rv(rv_str);
                  new_vtype           = new_vtype??vtype;
                  new_max_retry_times = new_max_retry_times??max_retry_times;
                  new_init_intv       = new_init_intv??intv;
                  ////
                  let new_rv_str;
                  if(new_arg_ary === _un) {     //参数被更新
                      new_rv_str    = _encd_rv(new_vtype,new_arg_ary,new_max_retry_times,new_intv);
                  } else {
                      if(new_vtype  !== vtype) { //参数没有更新 但是 编码类型更新
                          new_rv_str    = _encd_rv(new_vtype,new_arg_ary,new_max_retry_times,new_intv);
                      } else {
                          // 参数 与 编码类型 均未更新
                          let nrv     = [new_vtype,arg_ary_buf_str,new_max_retry_times,new_init_intv];
                          new_rv_str  =  _j2s(nrv);
                      }
                  }
                  let r = await this.rd_.del(id);       ////手动删除不会触发超时
                  await this.rd_.set(rid,new_rv_str);
                  await this.rd_.set(id,_nu);
                  pool[id]      = [new_handle,rid,new_next_intv_func]
                  await this.rd_.pexpire(id,new_init_intv);
                  return(_t)
              } else {
                  return(_f)
              }
         } else {
             return(_f)
         }
    }
    async cancel_retry_task(id) {
         let pool         = this.handle_pool;
         if(pool[id]) {
             let [handle,rid,next_intv_func] = pool[id];
             delete pool[id];
             await this.rd_.del(rid);
             // id 让 redis 自动删除
         } else { 
         }
    }
    async list_all() {
        //debug AND test only , very slow
        let arr=[];
        for(let id in this.handle_pool) {
            let [handle,rid,next_intv_func] = this.handle_pool[id];
            let  rv_str                      = await this.rd_.get(rid);
            if(rv_str!== _nu) {
                let [vtype,arg_ary,max_retry_times,intv,buf_str] = _decd_rv(rv_str);       
                arr.push(arg_ary);
            } else {
            }
        }
        return(arr)
    }
}

RRetry.MAX_20MIN_NEXT_INTV = MAX_20MIN_NEXT_INTV;
RRetry._encd_rv  = _encd_rv;
RRetry._decd_rv  = _decd_rv;
RRetry._updt_rv  = _updt_rv;

module.exports = RRetry;
